<i18n>
{
  "fr": {
    "question-1": "Vous êtes *",
    "researcher": "chercheur.e ou enseignant.e chercheur.e",
    "engineer": "ingénieur.e, technicien.ne, assistant.e ingénieur.e, personnel d'appui à la recherche",
    "student": "doctorant.e ou postdoctorant.e",
    "question-2-1": "En",
    "question-2-2": "en moyenne, lorsque vous n'étiez pas en congés,<br/> combien de jours par semaine vous êtes vous rendu⋅e sur votre lieu de travail ?",
    "question-2-loked": "en moyenne, lorsque vous n'étiez pas en congés et pas confiné.e,<br/> combien de jours par semaine vous êtes vous rendu⋅e sur votre lieu de travail ?",
    "placeholder-2": "Nombre de jours de déplacement par semaine",
    "day-per-week": "jour par semaine",
    "nb-day-per-week": "Nombre de jours par semaine",
    "days-per-week": "jours par semaine",
    "workplace-1": "lieu de travail",
    "workplace-2": "endroit où vous effectuez votre recherche ou votre travail d'appui à la recherche.",
    "workplace-3": "Exemple : Si vous enseignez dans un lieu et si vous effectuez votre recherche dans un autre lieu, il s’agit de prendre en compte votre lieu de recherche.",
    "question-3-1": "Quels modes de transport utilisiez-vous pour la journée-type de ",
    "question-3-2": " la plus fréquente ? <br /> (Possibilité de saisir une 2ème journée-type par la suite si vous avez des trajets bien différents dans une même semaine).",
    "question-4-1": "Quelles distances totales ALLER / RETOUR parcouriez-vous pour la journée-type de ",
    "question-4-2": " la plus fréquente ?",
    "question-5": "Avez vous une autre journée-type fréquente à déclarer en",
    "question-6-1": "Parmi vos",
    "question-6-2": "jour(s) de déplacements par semaine, combien de jours ce deuxième trajet concerne-t-il ?",
    "question-7": "Quels modes de transport utilisiez-vous pour cette deuxième journée-type de",
    "question-8": "Quelles distances totales ALLER / RETOUR parcouriez-vous pour cette deuxième journée-type de",
    "preview": "Aperçu avant soumission",
    "header-1": "Si vous ne connaissez pas les distances, vous pouvez vous référer à",
    "header-2": "Pour les transports en commun, référez-vous aux distances en voiture. Merci de NE PAS prendre en compte les éventuels points de passage (boulangerie, dépôt des enfants à l’école…).",
    "header-3": "Arrondissez au nombre entier le plus proche.",
    "engine": "Motorisation de la voiture",
    "n-persons-car": "Nombre de personnes dans la voiture",
    "n-persons-2weels": "Nombre de personnes sur le 2 roues motorisées",
    "previous": "Précédent",
    "next": "Suivant",
    "required": "Ce champ est obligatoire",
    "numeric": "Chiffres uniquement",
    "inferior": "Doit être inférieur ou égal à",
    "superior": "Doit être supérieur ou égal à",
    "superior-strict": "Doit être supérieur à",
    "distance-in": "Distance totale ALLER / RETOUR en",
    "km-day": "km / jour",
    "add-simu": "Ajouter la simulation",
    "add": "Ajouter"
  },
  "en": {
    "question-1": "You are *",
    "researcher": "a researcher or a professor",
    "engineer": "an engineer, a technician, an assistant engineer, research support staff",
    "student": "a PhD student or a Post-Doc",
    "question-2-1": "In",
    "question-2-2": "on average, when you were not on holidays,<br /> how many days per week did you go to your workplace ?",
    "question-2-loked": "on average, when you were not on holidays and not locked down,<br /> how many days per week did you go to your workplace ?",
    "placeholder-2": "Number of commuting days per week",
    "day-per-week": "day per week",
    "nb-day-per-week": "Number of days per week",
    "days-per-week": "days per week",
    "workplace-1": "workplace",
    "workplace-2": "place where you do your research or research-support activity.",
    "workplace-3": "Example :if you teach in one location and do your research in another location, please only consider your research location.",
    "question-3-1": "Which means of transportation did you take for your most frequent standard commute in ",
    "question-3-2": "? <br /> (you may enter a second standard commute after if you have very different commutes in the same week)",
    "question-4-1": "What total ROUND TRIP distances did you travel for your most frequent standard commute in ",
    "question-4-2": " ?",
    "question-5": "Do you have a second frequent standard commute to add in",
    "question-6-1": "Amoung your",
    "question-6-2": "commutes day(s) per week, how many days does this second commute cover ?",
    "question-7": "Which means of transportation did you take during this second standard commute in",
    "question-8": "What total ROUND TRIP distances did you travel during this second standard commute in",
    "preview": "Preview before submission ",
    "header-1": "If you don't know the distance, you can refer to",
    "header-2": "For public transportation modes, you may refer to the distances traveled by car. Please DO NOT take into account any possible detours (bakery, children's drop-off at school, etc.)",
    "header-3": "Round to the nearest integer.",
    "n-persons-car": "Number of persons in the car",
    "n-persons-2weels": "Number of persons on the motorized two-wheeler",
    "engine": "Car engine",
    "previous": "Previous",
    "next": "Next",
    "required": "This field is required",
    "numeric": "Numbers only",
    "inferior": "Must be less than or equal to",
    "superior": "Must be greater than or equal to",
    "superior-strict": "Must be greater than",
    "distance-in": "Total ROUND TRIP distance in",
    "km-day": "km / day",
    "add-simu": "Add the simulation",
    "add": "Add"
  }
}
</i18n>

<template>
  <form>
    <br />
    <center>
      <h1 v-if="isSimulation" class="title">Question {{ activeStep }}</h1>
      <h1 v-else class="title">Question {{ activeStep + 1 }}</h1>
    </center>
    <br />
    <div class="columns">
      <div class="column is-6 is-offset-3">
        <b-progress
          size="is-small"
          type="is-primary"
          :value="progressValue"
        ></b-progress>
      </div>
    </div>
    <center>
      <h6 class="subtitle is-6"><strong v-html="activeQuestion"></strong></h6>
    </center>
    <br />
    <b-notification
      v-if="!position && activeStep===0"
      :type="step1type"
      :closable="false"
    >
      <b-radio
        :type="step1type"
        name="position"
        v-validate="'required'"
        v-model="ccommute.position"
        native-value="researcher"
      >
        {{ $t('researcher') }}
      </b-radio>
      <br />
      <b-radio
        :type="step1type"
        name="position"
        v-validate="'required'"
        v-model="ccommute.position"
        native-value="engineer"
      >
        {{ $t('engineer') }}
      </b-radio>
      <br />
      <b-radio
        :type="step1type"
        name="position"
        v-validate="'required'"
        v-model="ccommute.position"
        native-value="student"
      >
        {{ $t('student') }}
      </b-radio>
      <b-field
        :type="step1type"
        :message="step1type ? $t('required') : ''"
      >
      </b-field>
    </b-notification>
    <b-notification
      v-if="activeStep===1"
      :closable="false"
      :type="step2type"
    >
      <b-field
        :type="step2type"
        :message="step2type ? $t('required') : ''"
      >
        <b-select
          name="nWorkingDay"
          expanded
          v-validate="'required'"
          :placeholder="$t('placeholder-2') + ' *'"
          v-model="ccommute.nWorkingDay"
        >
          <option :value="0"> 0 {{ $t('day-per-week') }}</option>
          <option :value="1"> 1 {{ $t('day-per-week') }}</option>
          <option :value="2"> 2 {{ $t('days-per-week') }}</option>
          <option :value="3"> 3 {{ $t('days-per-week') }}</option>
          <option :value="4"> 4 {{ $t('days-per-week') }}</option>
          <option :value="5"> 5 {{ $t('days-per-week') }}</option>
          <option :value="6"> 6 {{ $t('days-per-week') }}</option>
          <option :value="7"> 7 {{ $t('days-per-week') }}</option>
        </b-select>
      </b-field>
      <br />
      <strong>« {{ $t('workplace-1') }} »</strong> = {{ $t('workplace-2') }}
      <br />
      <em>{{ $t('workplace-3') }}</em>
    </b-notification>
    <div
      v-if="activeStep===2 && ccommute.nWorkingDay > 0"
      :type="step3type"
    >
      <div class="columns is-multiline is-centered">
        <div
          v-for="(mode,index) in TRAVELS_MODES"
          :key="index"
          class="column is-3"
        >
          <button
            class="button is-mode-deplacement is-fullwidth"
            type="button"
            :class="{ 'is-primary is-light': selectedMode1.includes(mode), 'is-danger': step3type !== '' }"
            @click="selectMode1(mode)"
          >
            <b-icon
              :pack="modeIconPack(mode)"
              :icon="modeIcon(mode)"
              style="padding-right: 20px"
            />
            <span> {{ $t(mode) }} </span>
          </button>
        </div>
      </div>
      <br />
    </div>
    <div v-if="activeStep===3">
      <b-notification
        :closable="false"
      >
        {{ $t('header-1') }} <a target="_blank" class="link" href="https://www.openstreetmap.org/directions">openstreetmap</a>.
        {{ $t('header-2') }}
        <br />
        {{ $t('header-3') }}
      </b-notification>
      <b-notification
        v-for="(mode,index) in selectedMode1"
        :type="errorsMsg1[index] ? 'is-danger' : ''"
        :closable="false"
        :key="index"
      >
        <b-field
          :label="$t('distance-in') + ' ' + $t(mode).toLowerCase() + ' (' + $t('km-day') + ')' + ' *'"
          :type="errorsMsg1[index] ? 'is-danger' : ''"
          :message="errorsMsg1[index]"
        >
          <b-input
            :icon="modeIcon(mode)"
            :icon-pack="modeIconPack(mode)"
            type="number"
            :placeholder="0"
            @input="modeInputChanged()"
            v-model="ccommute[mode]"
          ></b-input>
        </b-field>
        <b-field
          v-if="mode==='car'"
          :label="$t('engine') + ' *'"
          :type="engineErrorMsg1 ? 'is-danger' : ''"
          :message="engineErrorMsg1"
        >
          <b-select
            v-model="ccommute.engine"
            :placeholder="$t('engine') + ' *'"
            @change.native="modeInputChanged()"
            expanded
            :type="step4type"
          >
            <option
              :value="engine"
              v-for="(engine,index) in engines"
              :key="index"
            >
              {{ $t(engine) }}
            </option>
          </b-select>
        </b-field>
        <b-field
          v-if="mode==='car'"
          :label="$t('n-persons-car') + ' *'"
          :type="carpoolingErrorMsg1 ? 'is-danger' : ''"
          :message="carpoolingErrorMsg1"
        >
          <b-input
            v-model="ccommute.carpooling"
            type="number"
            @input="modeInputChanged()"
            expanded
          >
          </b-input>
        </b-field>
        <b-field
          v-if="mode==='motorbike'"
          :type="motorbikepoolingErrorMsg1 ? 'is-danger' : ''"
          :label="$t('n-persons-2weels') + ' *'"
          :message="motorbikepoolingErrorMsg1"
        >
          <b-input
            v-model="ccommute.motorbikepooling"
            @input="modeInputChanged()"
            type="number"
            expanded
          >
          </b-input>
        </b-field>
      </b-notification>
      <br />
    </div>
    <div
      v-if="activeStep===4 && ccommute.nWorkingDay > 1"
    >
      <div class="columns">
        <div class="column is-3 is-offset-3">
          <b-button
            expanded
            @click="switchhasWorkingDay2(true)"
            :type="step5typeY"
          > {{ $t('yes') }} </b-button>
        </div>
        <div class="column is-3">
          <b-button
            expanded
            @click="switchhasWorkingDay2(false)"
            :type="step5typeN"
          > {{ $t('no') }} </b-button>
        </div>
      </div>
      <br />
    </div>
    <b-notification
      v-if="activeStep===5 && ccommute.hasWorkingDay2"
      :closable="false"
      :type="step6type"
    >
      <b-field
        :type="step6type"
        :message="step6type ? $t('required') : ''"
      >
        <b-select
          name="nWorkingDay2"
          expanded
          v-validate="'required'"
          :placeholder="$t('nb-day-per-week') + ' *'"
          v-model="ccommute.nWorkingDay2"
        >
          <option
            v-for="(nbJ,index) in ccommute.nWorkingDay - 1"
            :key="index"
            :value="nbJ"
          >
            {{ nbJ }}
            <span v-if="nbJ>1">{{ $t('days-per-week') }}</span>
            <span v-else>{{ $t('day-per-week') }}</span>
          </option>
        </b-select>
      </b-field>
    </b-notification>
    <div
      v-if="activeStep===6 && ccommute.hasWorkingDay2"
      :type="step7type"
    >
      <div class="columns is-multiline is-centered">
        <div
          v-for="(mode,index) in TRAVELS_MODES"
          :key="index"
          class="column is-3"
        >
          <button
            class="button is-mode-deplacement is-fullwidth"
            type="button"
            :class="{ 'is-primary is-light': selectedMode2.includes(mode), 'is-danger': step7type !== '' }"
            @click="selectMode2(mode)"
          >
            <b-icon
              :pack="modeIconPack(mode)"
              :icon="modeIcon(mode)"
              style="padding-right: 20px"
            />
            <span> {{ $t(mode) }} </span>
          </button>
        </div>
      </div>
      <br />
    </div>
    <div v-if="activeStep===7">
      <b-notification
        :closable="false"
      >
        {{ $t('header-1') }} <a target="_blank" class="link" href="https://www.openstreetmap.org/directions">openstreetmap</a>.
        {{ $t('header-2') }}
        <br />
        {{ $t('header-3') }}
      </b-notification>
      <b-notification
        v-for="(mode,index) in selectedMode2"
        :key="index"
        :type="errorsMsg2[index] ? 'is-danger' : ''"
        :closable="false"
      >
        <b-field
          :label="$t('distance-in') + ' ' + $t(mode) + ' (' + $t('km-day') + ')'"
          :message="errorsMsg2[index]"
          :type="errorsMsg2[index] ? 'is-danger' : ''"
        >
          <b-input
            :icon="modeIcon(mode)"
            :icon-pack="modeIconPack(mode)"
            :placeholder="0"
            type="number"
            @input="modeInputChanged('2')"
            v-model="ccommute[mode + '2']"
          ></b-input>
        </b-field>
        <b-field
          v-if="mode==='car'"
          :label="$t('engine') + ' *'"
          :message="engineErrorMsg2"
          :type="engineErrorMsg2 ? 'is-danger' : ''"
        >
          <b-select
            v-model="ccommute.engine2"
            :placeholder="$t('engine') + ' *'"
            @change.native="modeInputChanged('2')"
            expanded
            :type="step4type"
          >
            <option
              :value="engine"
              v-for="(engine,index) in engines"
              :key="index"
            >
              {{ $t(engine) }}
            </option>
          </b-select>
        </b-field>
        <b-field
          v-if="mode==='car'"
          :label="$t('n-persons-car') + ' *'"
          :message="carpoolingErrorMsg2"
          :type="carpoolingErrorMsg2 ? 'is-danger' : ''"
        >
          <b-input
            v-model="ccommute.carpooling2"
            @input="modeInputChanged('2')"
            type="number"
            expanded
          >
          </b-input>
        </b-field>
        <b-field
          v-if="mode==='motorbike'"
          :label="$t('n-persons-2weels') + ' *'"
          :message="motorbikepoolingErrorMsg2"
          :type="motorbikepoolingErrorMsg2 ? 'is-danger' : ''"
        >
          <b-input
            v-model="ccommute.motorbikepooling2"
            @input="modeInputChanged('2')"
            type="number"
            expanded
          >
          </b-input>
        </b-field>
      </b-notification>
      <br />
    </div>
    <div class="columns">
      <div class="column">
        <b-button
          class="button is-fullwidth"
          :disabled="previousDisabled"
          @click="previousStep"
          icon-left="angle-double-left"
        >
          {{ $t('previous') }}
        </b-button>
      </div>
      <div class="column">
        <b-button
          class="button is-fullwidth is-primary"
          @click="nextStep"
          icon-right="angle-double-right"
        >
          {{ nextBtnLabel }}
        </b-button>
      </div>
    </div>
  </form>
</template>

<script>
import Commute from '@/models/carbon/Commute.js'
import Vehicle from '@/models/carbon/Vehicle.js'

export default {
  name: 'CommuteForm',
  props: {
    commute: {
      type: Object,
      default: function () {
        return {}
      }
    },
    year: {
      type: Number,
      default: new Date().getFullYear() - 1
    },
    isSurvey: {
      type: Boolean,
      default: false
    },
    isSimulation: {
      type: Boolean,
      default: false
    },
    position: {
      type: String,
      default: null
    },
    hasWorkingDay2Changed: {
      type: Boolean,
      default: false
    }
  },
  $_veeValidate: {
    validator: 'new'
  },
  data () {
    return {
      TRAVELS_MODES: Commute.travelsModes,
      ccommute: Object.assign({}, this.commute),
      motifsDeplacements: Commute.motifsDeplacements,
      errorFirstForm: false,
      errorSecondForm: false,
      selectedMode1: [],
      selectedMode2: [],
      errorsMsg1: [],
      errorsMsg2: [],
      engineErrorMsg1: null,
      engineErrorMsg2: null,
      carpoolingErrorMsg1: null,
      carpoolingErrorMsg2: null,
      motorbikepoolingErrorMsg1: null,
      motorbikepoolingErrorMsg2: null,
      activeStep: 0,
      step1type: '',
      step2type: '',
      step3type: '',
      step4type: '',
      step5typeY: '',
      step5typeN: '',
      step5type: '',
      step7type: '',
      step6type: '',
      step8type: ''
    }
  },
  watch: {
    'ccommute.position': function () {
      if (this.step1isOK) {
        this.step1type = ''
      } else {
        this.step1type = 'is-danger'
      }
    },
    'ccommute.nWorkingDay': function () {
      if (this.step2isOK) {
        this.step2type = ''
      } else {
        this.step2type = 'is-danger'
      }
      this.updateModes()
    },
    'ccommute.nWorkingDay2': function () {
      if (this.step6isOK) {
        this.step6type = ''
      } else {
        this.step6type = 'is-danger'
      }
    },
    'ccommute.hasWorkingDay2': function () {
      this.updateModes()
    }
  },
  computed: {
    progressValue: function () {
      if (this.isSimulation) {
        return (this.activeStep - 1) / (this.totalStep - 1) * 100
      } else {
        return this.activeStep / this.totalStep * 100
      }
    },
    engines: function () {
      return Vehicle.getEngines('car')
    },
    previousDisabled: function () {
      if (this.isSimulation) {
        return this.activeStep === 1
      } else {
        return this.activeStep === 0
      }
    },
    nextBtnLabel: function () {
      if (!this.isSimulation && this.isSurvey && this.activeStep === this.totalStep) {
        return this.$t('preview')
      } if (this.isSimulation && this.activeStep === this.totalStep) {
        return this.$t('add-simu')
      } if (!this.isSimulation && !this.isSurvey && this.activeStep === this.totalStep) {
        return this.$t('add')
      } else {
        return this.$t('next')
      }
    },
    totalStep: function () {
      if (this.ccommute.nWorkingDay === 0) {
        return 1
      } else if (this.ccommute.nWorkingDay === 1) {
        return 3
      } else if (this.hasWorkingDay2Changed && !this.ccommute.hasWorkingDay2) {
        return 4
      } else {
        return 7
      }
    },
    activeQuestion: function () {
      if (this.activeStep === 0) {
        return this.$t('question-1')
      } else if (this.activeStep === 1) {
        return this.labelQuestion2
      } else if (this.activeStep === 2) {
        return this.$t('question-3-1') + this.year + this.$t('question-3-2')
      } else if (this.activeStep === 3) {
        return this.$t('question-4-1') + this.year + this.$t('question-4-2')
      } else if (this.activeStep === 4) {
        return this.$t('question-5') + ' ' + this.year + ' ?'
      } else if (this.activeStep === 5) {
        return this.$t('question-6-1') + ' ' + this.ccommute.nWorkingDay + ' ' + this.$t('question-6-2')
      } else if (this.activeStep === 6) {
        return this.$t('question-7') + ' ' + this.year + ' ?'
      } else if (this.activeStep === 7) {
        return this.$t('question-8') + ' ' + this.year + ' ?'
      } else {
        return ''
      }
    },
    labelQuestion2: function () {
      var label = this.$t('question-2-1') + ' ' + this.year + ', '
      if (this.year === 2020 || this.year === 2021) {
        label += this.$t('question-2-loked')
      } else {
        label += this.$t('question-2-2')
      }
      return label + ' *'
    },
    step1isOK: function () {
      return this.ccommute.position !== null
    },
    step2isOK: function () {
      return this.ccommute.nWorkingDay !== null
    },
    step3isOK: function () {
      return this.selectedMode1.length > 0
    },
    step4isOK: function () {
      return this.step3isOK && this.modesAreValid()
    },
    step5isOK: function () {
      return this.hasWorkingDay2Changed
    },
    step6isOK: function () {
      return this.ccommute.nWorkingDay2 !== null
    },
    step7isOK: function () {
      return this.selectedMode2.length > 0
    },
    step8isOK: function () {
      return (this.step5isOK && this.ccommute.nWorkingDay2 !== null && this.modesAreValid('2'))
    }
  },
  methods: {
    modeIcon: function (mode) {
      return Commute.getIcon(mode)
    },
    modeIconPack: function (mode) {
      return Commute.getIconPack(mode)
    },
    modeMaxDistance: function (mode) {
      return Commute.getMaxDistance(mode)
    },
    modeInputChanged (prefix = '') {
      this.modesAreValid(prefix)
    },
    modesAreValid (prefix = '') {
      let isOK = true
      let prefixVar = prefix
      if (prefixVar === '') {
        prefixVar = '1'
      }
      this['errorsMsg' + prefixVar] = Array(this['selectedMode' + prefixVar]).fill(null)
      this.engineErrorMsg1 = null
      this.engineErrorMsg2 = null
      this.carpoolingErrorMsg1 = null
      this.carpoolingErrorMsg2 = null
      this.motorbikepoolingErrorMsg1 = null
      this.motorbikepoolingErrorMsg2 = null
      let index = 0
      for (let mode of this['selectedMode' + prefixVar]) {
        if (this.ccommute[mode + prefix] === null) {
          isOK = false
          this['errorsMsg' + prefixVar][index] = this.$t('required')
        } else if (isNaN(parseInt(this.ccommute[mode + prefix]))) {
          isOK = false
          this['errorsMsg' + prefixVar][index] = this.$t('numeric')
        } else if (parseInt(this.ccommute[mode + prefix]) < 1) {
          isOK = false
          this['errorsMsg' + prefixVar][index] = this.$t('superior-strict') + ' 0'
        } else if (parseInt(this.ccommute[mode + prefix]) > this.modeMaxDistance(mode)) {
          isOK = false
          this['errorsMsg' + prefixVar][index] = this.$t('inferior') + ' ' + this.modeMaxDistance(mode)
        } else {
          this['errorsMsg' + prefixVar][index] = null
        }
        if (mode === 'car' && this.ccommute['engine' + prefix] === null) {
          isOK = false
          this['engineErrorMsg' + prefixVar] = this.$t('required')
        }
        if (mode === 'car' && parseInt(this.ccommute['carpooling' + prefix]) < 1) {
          isOK = false
          this['carpoolingErrorMsg' + prefixVar] = this.$t('superior') + ' 1'
        } else if (mode === 'car' && parseInt(this.ccommute['carpooling' + prefix]) > 10) {
          isOK = false
          this['carpoolingErrorMsg' + prefixVar] = this.$t('inferior') + ' 10'
        } else if (mode === 'car' && isNaN(parseInt(this.ccommute['carpooling' + prefix]))) {
          isOK = false
          this['carpoolingErrorMsg' + prefixVar] = this.$t('numeric')
        }
        if (mode === 'motorbike' && parseInt(this.ccommute['motorbikepooling' + prefix]) < 1) {
          isOK = false
          this['motorbikepoolingErrorMsg' + prefixVar] = this.$t('superior') + ' 1'
        } else if (mode === 'motorbike' && parseInt(this.ccommute['motorbikepooling' + prefix]) > 3) {
          isOK = false
          this['motorbikepoolingErrorMsg' + prefixVar] = this.$t('inferior') + ' 3'
        } else if (mode === 'motorbike' && isNaN(parseInt(this.ccommute['motorbikepooling' + prefix]))) {
          isOK = false
          this['motorbikepoolingErrorMsg' + prefixVar] = this.$t('numeric')
        }
        index += 1
      }
      if (isOK) {
        if (prefix === '') {
          this.step4type = ''
        } else {
          this.step8type = ''
        }
      } else {
        if (prefix === '') {
          this.step4type = 'is-danger'
        } else {
          this.step8type = 'is-danger'
        }
      }
      return isOK
    },
    selectMode1 (mode) {
      if (this.selectedMode1.includes(mode)) {
        this.selectedMode1.splice(this.selectedMode1.indexOf(mode), 1)
        this.ccommute[mode] = 0
      } else {
        this.selectedMode1.push(mode)
      }
      if (this.selectedMode1.length > 0) {
        this.step3type = ''
      }
    },
    selectMode2 (mode) {
      if (this.selectedMode2.includes(mode)) {
        this.selectedMode2.splice(this.selectedMode2.indexOf(mode), 1)
        this.ccommute[mode + '2'] = 0
      } else {
        this.selectedMode2.push(mode)
      }
      if (this.selectedMode2.length > 0) {
        this.step7type = ''
      }
    },
    updateModes () {
      if (this.ccommute.nWorkingDay === 0) {
        this.ccommute.hasWorkingDay2 = false
        for (let mode of this.TRAVELS_MODES) {
          this.ccommute[mode] = 0
          this.selectedMode1 = []
        }
      } else if (this.ccommute.nWorkingDay === 1) {
        this.ccommute.hasWorkingDay2 = false
      }
      if (!this.ccommute.hasWorkingDay2) {
        this.nWorkingDay2 = 0
        for (let mode of this.TRAVELS_MODES) {
          this.ccommute[mode + '2'] = 0
          this.selectedMode2 = []
        }
      }
    },
    switchhasWorkingDay2 (value) {
      this.ccommute.hasWorkingDay2 = value
      this.$emit('update:hasWorkingDay2Changed', true)
      if (value) {
        this.step5typeY = 'is-primary is-light'
        this.step5typeN = ''
      } else {
        this.step5typeY = ''
        this.step5typeN = 'is-primary is-light'
      }
    },
    nextStep () {
      if (this.activeStep === 0) {
        if (this.step1isOK) {
          this.activeStep = 1
        } else {
          this.step1type = 'is-danger'
        }
      } else if (this.activeStep === 1 && this.step1isOK && this.ccommute.nWorkingDay === 0) {
        if (this.step2isOK) {
          this.$emit('submit', this.ccommute)
        } else {
          this.step2type = 'is-danger'
        }
      } else if (this.activeStep === 1 && this.step1isOK) {
        if (this.step2isOK) {
          this.activeStep = 2
        } else {
          this.step2type = 'is-danger'
        }
      } else if (this.activeStep === 2 && this.step2isOK) {
        if (this.step3isOK) {
          this.activeStep = 3
        } else {
          this.step3type = 'is-danger'
        }
      } else if (this.activeStep === 3 && this.step3isOK && this.ccommute.nWorkingDay === 1) {
        if (this.step4isOK) {
          this.$emit('submit', this.ccommute)
        } else {
          this.step4type = 'is-danger'
        }
      } else if (this.activeStep === 3 && this.step3isOK) {
        if (this.step4isOK) {
          this.activeStep = 4
        } else {
          this.step4type = 'is-danger'
        }
      } else if (this.activeStep === 4 && this.step4isOK && !this.ccommute.hasWorkingDay2) {
        if (this.step5isOK) {
          this.$emit('submit', this.ccommute)
        } else {
          this.step5typeY = 'is-danger is-light'
          this.step5typeN = 'is-danger is-light'
        }
      } else if (this.activeStep === 4 && this.step4isOK) {
        if (this.step5isOK) {
          this.activeStep = 5
        } else {
          this.step5typeY = 'is-danger is-light'
          this.step5typeN = 'is-danger is-light'
        }
      } else if (this.activeStep === 5 && this.step5isOK) {
        if (this.step6isOK) {
          this.activeStep = 6
        } else {
          this.step6type = 'is-danger'
        }
      } else if (this.activeStep === 6 && this.step6isOK) {
        if (this.step7isOK) {
          this.activeStep = 7
        } else {
          this.step7type = 'is-danger'
        }
      } else if (this.activeStep === 7 && this.step7isOK) {
        if (this.step8isOK) {
          this.$emit('submit', this.ccommute)
        } else {
          this.step8type = 'is-danger'
        }
      }
    },
    previousStep () {
      if (this.isSimulation && this.activeStep > 1) {
        this.activeStep -= 1
      } else if (!this.isSimulation && this.activeStep > 0) {
        this.activeStep -= 1
      } else {
        this.$emit('back')
      }
    },
    closeForm: function () {
      this.$emit('close')
    }
  },
  mounted () {
    if (this.position) {
      this.ccommute.position = this.position
    }
    if (this.isSimulation) {
      this.activeStep = 1
    }
    if (this.hasWorkingDay2Changed) {
      if (this.ccommute.hasWorkingDay2) {
        this.step5typeY = 'is-primary is-light'
        this.step5typeN = ''
      } else {
        this.step5typeY = ''
        this.step5typeN = 'is-primary is-light'
      }
    }
    for (let mode of this.TRAVELS_MODES) {
      if (this.ccommute[mode] > 0) {
        this.selectedMode1.push(mode)
      }
      if (this.ccommute[mode + '2'] > 0) {
        this.selectedMode2.push(mode)
      }
    }
  }
}
</script>

<style>
  .notification.is-danger {
    background-color: #fbf4f6 !important;
  }
  .button.is-primary.is-light {
    background-color: #e5f0fb !important;
    color: #296fa8 !important;
  }
  .button.is-danger.is-light {
    background-color: #fde0e6 !important;
    color: #cc0f35 !important;
  }
  .button.is-mode-deplacement {
    padding: 50px;
    font-size: 18px;
    white-space: normal;
  }
  .button.is-mode-deplacement.is-danger {
    background-color: #fde0e6;
    border-color: transparent;
    color: #cc0f35;
  }
</style>
